<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>41.55</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
       
         <div class="row form-group ">
          <div class="col-2">
            <lable class="label">Trạng thái Order</lable>
          </div>
          <div class="col-3">
            <select class="form-control" id="slt-status">
                <option value="0">All</option>
                <option value="open">Open</option>
                <option value="confirmed">Confirmed</option>
                <option value="cancel">Cancel</option>
            </select>
          </div>
          <div class="col-2">
            <label class="label">Loại Pizza</label>
          </div>
          <div class="col-3">
           <select class="form-control" id="slt-pizza-type">
                <option value="0">All</option>
                <option value="Hawaii">Hawaii</option>
                <option value="bacon">Bacon</option>
                <option value="Seafood">Seafood</option>
           </select>
          </div>
          <div class="col-2">
            <button id="btn-filter" class="btn btn-primary">Filter</button>
          </div>
          
         </div>
        
        
        <table class="table table-bordered table-striped table-hover" id="don-table">
          <thead>
            <tr>
              <th>Order code</th>
              <th>Kich cỡ Combo</th>
              <th>Loại Pizza</th>
              <th>Nước Uống</th>
              <th>Thành Tiền</th>
              <th>Họ và tên</th>
              <th>số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
        </table>
      </div>
</body>
<script>
    var gListUser;
    $(document).ready(function(){
       /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
       //creata a data for DataTable
       
       const gCOLUMN_ID = 0;
        const gCOLUMN_KICH_CO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_NUOC_UONG = 3;
        const gCOLUMN_THANH_TIEN = 4 ;
        const gCOLUMN_HO_TEN = 5;
        const gCOLUMN_SO_DIENTHOAI = 6;
        const gCOLUMN_TRANGTHAI = 7;
        const gCOLUMN_ACTION = 8;

        const gNAME_COL = ["id","duongKinh","loaiPizza","idLoaiNuocUong",
            "thanhTien","hoTen","soDienThoai","trangThai","Action"];
            
            // định nghĩa table  - chưa có data
            var gUserTable = $("#don-table").DataTable( {
            // Khai báo các cột của datatable
            "columns" : [
                { "data" : gNAME_COL[gCOLUMN_ID] },
                { "data" : gNAME_COL[gCOLUMN_KICH_CO] },
                { "data" : gNAME_COL[gCOLUMN_LOAI_PIZZA] },
                { "data" : gNAME_COL[gCOLUMN_NUOC_UONG] },
                { "data" : gNAME_COL[gCOLUMN_THANH_TIEN] },
                { "data" : gNAME_COL[gCOLUMN_HO_TEN] },
                { "data" : gNAME_COL[gCOLUMN_SO_DIENTHOAI] },
                { "data" : gNAME_COL[gCOLUMN_TRANGTHAI] },
                { "data" : gNAME_COL[gCOLUMN_ACTION] }
            ],
            // Ghi đè nội dung của cột action, chuyển thành button chi tiết
            "columnDefs": [ 
            {
                "targets": gCOLUMN_ACTION,
                "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
            }]
            });
        onPageLoading();
       /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    //function on Button chi tiet click
    $("#don-table").on("click",".info-user",function(){
            console.log("xử lý chi tiết");
            var vCurrentInfo = getCurrentInfo(this);
            console.log(vCurrentInfo);
       })

    //function on button Filter Click
    $("#btn-filter").on("click",function(){
        var vFilter = btnFilterClick()
        debugger;
        console.log(vFilter);
       loadDataToTable(vFilter);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    //function on click filter
    function btnFilterClick(){
        var vResult = [];
        var vStatus = $("#slt-status").val();
        var PizzaType = $("#slt-pizza-type").val();
        var vResult = gListUser.filter(function(item){
            return (vStatus === item.trangThai || PizzaType === item.loaiPizza ||
            vStatus === 0 && PizzaType === 0);
        })

        return vResult;
    }
    
      
       //function load dataa for beginning
    function onPageLoading(){
        $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          loadDataToTable(responseObject);
          gListUser = responseObject;
          console.log(gListUser);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
       /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gUserTable.clear();
      //Cập nhật data cho bảng 
      gUserTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gUserTable.draw();
    }
    })

    //function get Current info on click button Chi tiet
    function getCurrentInfo(paraBtn){
        var vTrCurrent = $(paraBtn).closest("tr");
        var vTable = $("#don-table").DataTable();
        var vCurrentInfo = vTable.row(vTrCurrent).data();
        return vCurrentInfo;
    }
</script>
</html>